(* SEMANTIC DOMAINS *)


exception Nonstorable
exception Nonexpressible

type pointer = int 
type eval =  	   
	| Int of int 
	| Bool of bool
	| Novalue
	| Funval of efun 
	| Object of pointer 
	
and efun =  exp * (dval env) (* cambiato *)
and proc =  exp * (dval env) (* cambiato *)
and eclass = cdecl * (dval env) (* cambiato *)


		
and obj = dval env 	
and heap = pointer -> obj 

and dval =  	   
	| Dint of int 
	| Dbool of bool 
	| Unbound
	| Dloc of loc
	| Dfunval of efun
	| Dprocval of proc 
	| Dobject of pointer 
	| Classval of eclass 
	
and mval = 
	| Mint of int
	| Mbool of bool
	| Undefined
	| Mobject of pointer 
	
let evaltomval e = match e with
	| Int n -> Mint n
	| Bool n -> Mbool n
	| Object n -> Mobject n 
	| _ -> raise Nonstorable
	
let mvaltoeval m = match m with
	| Mint n -> Int n
	| Mbool n -> Bool n
	| Mobject n -> Object n 
	| _ -> Novalue
	
let evaltodval e = match e with
	| Int n -> Dint n
	| Bool n -> Dbool n
	| Novalue -> Unbound
	| Funval f -> Dfunval f
	| Object n -> Dobject n
	
let dvaltoeval e = match e with
	| Dint n -> Int n
	| Dbool n -> Bool n
	| Dloc n -> raise Nonexpressible
	| Dprocval n -> raise Nonexpressible
	| Unbound -> Novalue
	| Dfunval f -> Funval f
	| Dobject n -> Object n
	| Classval n ->  raise Nonexpressible


let (newpoint,initpoint) =
   let count = ref(-1) in
   (fun () -> count := !count +1;
	      !count),
   (fun () -> count := -1)
   

let emptyheap () = initpoint(); ((function (x: pointer) -> emptyenv Unbound): heap) 
  
let applyheap ((x: heap), (y:pointer)) = x y

let allocateheap ((x:heap), (i:pointer), (r:obj)) = 
    ((function j -> if j = i then r else x j):heap)
    
let notoccur ((i:ide), l) = let vl = ref(l) in
      let res = ref(true) in
      while not (!vl = []) do
	 if i = List.hd(!vl) then (res := false; vl := [])
	     else vl := List.tl(!vl)
      done;
      !res
      
let findone ((args: ide list), (el: dval list), (s: ide )) =   
          let vargs = ref(args) in
	  let dargs = ref(el) in
	      let valore = ref(Unbound) in
	      while not(!vargs = [])  do 
		if s = List.hd !vargs then 
		(vargs := []; valore := List.hd !dargs) 
		else  vargs := List.tl !vargs; dargs := List.tl !dargs
	      done;
	      !valore      
let findsuperargs ((args: ide list) ,(el: dval list) , (sargs: ide list)) = 
   let vsargs = ref(sargs) in
   let res = ref([]) in
   while not(!vsargs = []) do
     let i = findone(args, el, List.hd(!vsargs)) in
     if i = Unbound then failwith("problem with super parameters")
     else  res := !res @ [i]; vsargs := List.tl !vsargs
   done;
   !res

		 
let localenv ((env1:dval env) ,(li:ide list), (envv:dval env)) = 
 (function (j:ide) -> (if notoccur( j, li) & applyenv(envv,j) = Unbound then
     env1 j else Unbound):dval env)
     
let eredita ((env1:dval env) ,Object(n), (h:heap)) = 
  let r = applyheap(h, n) in
  (function (i:ide) ->
     (if r i = Unbound then env1 i else r i):(dval env))


