module Stato

type labeledconstruct =
  | Expr1 of exp
  | Expr2 of exp
  | Exprd1 of exp
  | Exprd2 of exp
  | Com1 of com
  | Com2 of com
  | Coml of labeledconstruct list
  | Decl of labeledconstruct list
  | Dec1 of (ide * exp)
  | Dec2 of (ide * exp)

let (cstack: labeledconstruct stack stack) =
  emptystack(stacksize,emptystack(1,Expr1(Eint(0))))

let (tempvalstack: eval stack stack) =
  emptystack(stacksize,emptystack(1,Novalue))

let (tempdvalstack: dval stack stack) =
  emptystack(stacksize,emptystack(1,Unbound))

let labelcom (dl: com list) =
  let dlr = ref(dl)
  let ldlr = ref([])
  while not (!dlr = []) do
    let i = List.head !dlr
    ldlr := !ldlr @ [Com1(i)]
    dlr := List.tail !dlr
  done
  Coml(!ldlr)

let labeldec (dl: (ide * exp) list) =
  let dlr = ref(dl)
  let ldlr = ref([])
  while not (!dlr = []) do
    let i = List.head !dlr in
    ldlr := !ldlr @ [Dec1(i)]
    dlr := List.tail !dlr
  done
  Decl(!ldlr)

let envstack: dval env stack = emptystack(stacksize,(emptyenv Unbound))

let storestack: mval store stack = emptystack(stacksize,(emptystore Undefined))

let pushenv(r) = push(r,envstack)

let topenv() = top(envstack)

let popenv () = pop(envstack)

let svuotaenv() = svuota(envstack)

let pushstore(s) = push(s,storestack)

let popstore () = pop(storestack)

let svuotastore () = svuota(storestack)

let topstore() = top(storestack)

let (labelstack: labeledconstruct stack) =
  emptystack(stacksize,Expr1(Eint(0)))
