(* SYNTACTIC DOMAINS *)

    type ide = string 
    type exp = 
      | Eint of int 
      | Ebool of bool 
      | Den of ide
      | Prod of exp * exp
      | Sum of exp * exp
      | Diff of exp * exp
      | Eq of exp * exp
      | Minus of exp
      | Iszero of exp
      | Or of exp * exp
      | And of exp * exp
      | Not of exp
      | Ifthenelse of exp * exp * exp	  
      | Let of ide * exp * exp
	  
      | Val of exp
	  
      | Newloc of exp
	and decl = (ide * exp) list 
	and block = (ide * exp) list  * com list
	
    and com = 
       | Assign of exp * exp
	   | Cifthenelse of exp * com list * com list
	   | While of exp * com list
	   
	   | Block of block
	   
   
