module Soperations

let typecheck (x, y) =
  match x with
  | "int" ->
    (match y with
      | Int(u) -> true
      | _ -> false)
  | "bool" ->
    (match y with
      | Bool(u) -> true
      | _ -> false)
  | _ -> failwith ("not a valid type")

let minus x =
  match x with
    | Int(y) -> Int(-y)
    | _ -> failwith ("type error")

let iszero x =
  match x with
    | Int(y) -> Bool(y=0)
    | _ -> failwith ("type error")

let equ (x,y) =
  match (x,y) with
    | (Int(u), Int(w)) -> Bool(u = w)
    | _ -> failwith ("type error")

let plus (x,y) =
  match (x,y) with
    | (Int(u), Int(w)) -> Int(u+w)
    | _ -> failwith ("type error")

let diff (x,y) =
  match (x,y) with
    | (Int(u), Int(w)) -> Int(u-w)
    | _ -> failwith ("type error")

let mult (x,y) =
  match (x,y) with
    | (Int(u), Int(w)) -> Int(u*w)
    | _ -> failwith ("type error")

let et (x,y) =
  match (x,y) with
    | (Bool(u), Bool(w)) -> Bool(u && w)
    | _ -> failwith ("type error")

let vel (x,y) =
  match (x,y) with
    | (Bool(u), Bool(w)) -> Bool(u || w)
    | _ -> failwith ("type error")

let non x =
  match x with
    | Bool(y) -> Bool(not y)
    | _ -> failwith ("type error")
