
(*SEMANTIC EVALUATION FUNCTIONS  *)


				
let rec sem ((e:exp), (r:eval env)) =
      match e with
      | Eint(n) -> Int(n)
      | Ebool(b) -> Bool(b)
      | Den(i) -> applyenv(r,i)
      | Iszero(a) -> iszero(sem(a, r))
      | Eq(a,b) -> equ(sem(a, r), sem(b, r))
      | Prod(a,b) ->  mult (sem(a, r), sem(b, r))
      | Sum(a,b) ->  plus (sem(a, r), sem(b, r))
      | Diff(a,b)  ->  diff (sem(a, r), sem(b, r))
      | Minus(a) ->  minus(sem(a, r))
      | And(a,b) ->  et (sem(a, r), sem(b, r))
      | Or(a,b) ->  vel (sem(a, r), sem(b, r))
      | Not(a) -> non(sem(a, r))
      | Ifthenelse(a,b,c) -> 
            let g = sem(a, r) in
            if typecheck("bool",g) then
               (if g = Bool(true) 
               then sem(b, r)
               else sem(c, r))
            else failwith ("nonboolean guard") 
	  
	  

	  


