type 't env = int

and eval =	   
     | Int of int 
     | Bool of bool 
     | Unbound
     | Funval of efun 
	 
and efun = exp * (eval env)


type labeledconstruct = 
   | Expr1 of exp 
   | Expr2 of exp

	 
let (cstack: labeledconstruct stack stack) = 
     emptystack(stacksize,emptystack(1,Expr1(Eint(0))))

let (tempvalstack: eval stack stack) = 
     emptystack(stacksize,emptystack(1,Unbound))
	 

let (currentenv: eval env ref) = ref(0)

let namestack = emptystack(stacksize,[| "dummy" |])

let evalstack = emptystack(stacksize,[| Unbound |])

let slinkstack = emptystack(stacksize, !currentenv)

type tag = Retained| Standard

let tagstack = emptystack(stacksize, Standard)

let applyenv ((x: eval env), (y: ide)) = 
       let n = ref(x) in
       let den = ref(Unbound) in
       while !n > -1 do
	     let lenv = access(namestack,!n) in
		 let nl = Array.length lenv in
		 let index = ref(0) in
		 while !index < nl do
	  if Array.get lenv !index = y then
	  (den := Array.get (access(evalstack,!n)) !index;
	  index := nl)
		  else index := !index + 1
		 done;
	 if not(!den = Unbound) then  n := -1
		 else n := access(slinkstack,!n)
       done;
       !den
	   
let bind ((r:eval env),i,d) = 
	push(Array.create 1 i,namestack); 
	push(Array.create 1 d,evalstack);
	push(r,slinkstack);
	push(Standard,tagstack);
	(lungh(namestack): eval env)
		
let bindlist(r, il, el) = 
   let n = List.length il in
   let ii = Array.create n "dummy" in
   let dd = Array.create n Unbound in
   let ri = ref(il) in
   let rd = ref(el) in
   let index = ref(0) in
   while !index < n do
     let i = List.hd !ri in
	 let d = List.hd !rd in
	 ( ri := List.tl !ri;
	   rd := List.tl !rd;
	   Array.set ii !index i;
	   Array.set dd !index d;
	   index := !index + 1)
    done;
    push(ii, namestack);
    push(dd,evalstack);
    push(r,slinkstack);
    push(Standard,tagstack);
    (lungh(namestack): eval env)
	
let emptyenv(x) = currentenv := -1; svuota(namestack);
   svuota(evalstack); svuota(slinkstack); svuota(tagstack);
   !currentenv

let svuotaenv() = svuota(namestack); svuota(tagstack);
    svuota(evalstack); svuota(slinkstack)

let topenv() = !currentenv

let popenv () = pop(namestack);
	  pop(evalstack);
	  pop(slinkstack);
	  pop(tagstack);
	  currentenv := !currentenv - 1
	  
let pushenv(r) = if r = !currentenv then 
	   (push([||],namestack);
	   push([||],evalstack);
	   push(Standard,tagstack);
	   push(r,slinkstack);
	   currentenv := lungh(namestack) )
	 else currentenv := r
	 
let pushargs ((b: exp list),continuation) = let br = ref(b) in
	     while not(!br = []) do
		   push(Expr1(List.hd !br),continuation);
		   br := List.tl !br
		 done

let getargs ((b: exp list),(tempstack: eval stack)) = let br = ref(b) in
	     let er = ref([]) in
	     while not(!br = []) do
		   let arg=top(tempstack) in
	       pop(tempstack); er := !er @ [arg];
		   br := List.tl !br
		 done;
		 !er
let retained (n:eval env) = access(tagstack,n) = Retained 
				

let retain () = 
       setta(tagstack, !currentenv, Retained);
       let cont = ref(lungh(namestack)) in
       while !cont > -1  & retained(!cont) do cont := !cont - 1 done;
       currentenv := !cont
       
let to_be_retained (v:eval) = match v with
   | Funval (e, r1) -> not(r1 < !currentenv)
   | _ -> false
(* si potrebbero recuperare alcuni frames retained *)
let retainorpopenv (r, valore) =
   if (topenv() = r) then () else
   if !currentenv < lungh(namestack) then retain() else
   if to_be_retained(valore) then retain() else
      (popenv();
      let index = ref(!currentenv) in
	  while !index > r do
	   if retained(!index) then (currentenv := !currentenv - 1;
	   index := !index -1) else (index := r) done )
	   
let collectretained (r) = let index = ref(lungh(namestack)) in
	  while !index > r do
	   pop(namestack); pop(evalstack);
	   pop(slinkstack); pop(tagstack);
	   index := !index -1  done;
	   currentenv := lungh(namestack) 
