module StaticSyntax

(*
staticexp uguale ad exp per tutti i costrutti che non contengono ide.
Ide viene eliminato dai costrutti statici corrispondenti.
Den ide viene cambiato in Access 

*)
type staticexp =
  | SUnbound
  | SInt of int
  | SBool of bool
  | Access of int * int
  | Smult of staticexp * staticexp
  | Splus of staticexp * staticexp
  | Sdiff of staticexp * staticexp
  | Sequ of staticexp * staticexp
  | Sminus of staticexp
  | Siszero of staticexp
  | Svel of staticexp * staticexp
  | Set of staticexp * staticexp
  | Snon of staticexp
  | Sifthenelse of staticexp * staticexp * staticexp
  | SBind of staticexp * staticexp
  | SFun of staticexp
  | SAppl of staticexp * staticexp list
  | SRec of staticexp
