module Stato

type labeledconstruct =
  | Expr1 of exp
  | Expr2 of exp

let (cstack: labeledconstruct stack stack) =
  emptystack(stacksize,emptystack(1,Expr1(Eint(0))))

let (tempvalstack: eval stack stack) =
  emptystack(stacksize,emptystack(1,Unbound))

let (envstack: eval env stack) =
  emptystack(stacksize,emptyenv(Unbound))

let pushenv(r) = push(r,envstack)

let topenv() = top(envstack)

let svuotaenv() = svuota(envstack)

let popenv () = pop(envstack)

let pushargs ((b: exp list),continuation) =
  let br = ref(b)
  while not(!br = []) do
    push(Expr1(List.head !br),continuation);
    br := List.tail !br
  done

let getargs ((b: exp list),(tempstack: eval stack)) =
  let br = ref(b)
  let er = ref([])
  while not(!br = []) do
    let arg=top(tempstack)
    pop(tempstack); er := !er @ [arg];
    br := List.tail !br
  done
  !er
