module StaticSyntax

(* SYNTACTIC DOMAINS *)

type ide = string

type exp =
  | Eint of int
  | Ebool of bool
  | Den of ide
  | Prod of exp * exp
  | Sum of exp * exp
  | Diff of exp * exp
  | Eq of exp * exp
  | Minus of exp
  | Iszero of exp
  | Or of exp * exp
  | And of exp * exp
  | Not of exp
  | Ifthenelse of exp * exp * exp
  | Let of ide * exp * exp
  | Fun of ide list * exp
  | Appl of exp * exp list
  | Rec of ide * exp

type staticexp =
  | StaticEint of int
  | StaticEbool of bool
  | StaticDen of int * int
  | StaticProd of exp * exp
  | StaticSum of exp * exp
  | StaticDiff of exp * exp
  | StaticEq of exp * exp
  | StaticMinus of exp
  | StaticIszero of exp
  | StaticOr of exp * exp
  | StaticAnd of exp * exp
  | StaticNot of exp
  | StaticIfthenelse of exp * exp * exp
  | StaticLet of int * int * exp * exp
  | StaticFun of (int * int) list * exp
  | StaticAppl of exp * exp list
  | StaticRec of int * int * exp
