module Eval

(* SEMANTIC DOMAINS *)

exception Nonstorable
exception Nonexpressible

type eval =
  | Int of int
  | Bool of bool
  | Novalue
  | Funval of efun
and efun =  (dval list) * (mval store) -> eval
and proc =  (dval list) * (mval store) -> mval store
and dval =
  | Dint of int
  | Dbool of bool
  | Unbound
  | Dloc of loc
  | Dfunval of efun
  | Dprocval of proc
and mval =
  | Mint of int
  | Mbool of bool
  | Undefined

let evaltomval =
  function
    | Int n -> Mint n
    | Bool n -> Mbool n
    | _ -> raise Nonstorable

let mvaltoeval =
  function
    | Mint n -> Int n
    | Mbool n -> Bool n
    | _ -> Novalue

let evaltodval =
  function
    | Int n -> Dint n
    | Bool n -> Dbool n
    | Novalue -> Unbound
    | Funval f -> Dfunval f

let dvaltoeval =
  function
    | Dint n -> Int n
    | Dbool n -> Bool n
    | Dloc n -> raise Nonexpressible
    | Unbound -> Novalue
    | Dfunval f -> Funval f
