

type labeledconstruct = 
   | Expr1 of exp 
   | Expr2 of exp
   | Exprd1 of exp
   | Exprd2 of exp
   | Com1 of com
   | Com2 of com
   | Coml of labeledconstruct list
   | Decl of labeledconstruct list
   | Rdecl of (ide * exp) list
   | Dec1 of (ide * exp) 
   | Dec2 of (ide * exp) 

let (cstack: labeledconstruct stack stack) = 
  emptystack(stacksize,emptystack(1,Expr1(Eint(0))))

let (tempvalstack: eval stack stack) = emptystack(stacksize,emptystack(1,Novalue))

let (tempdvalstack: dval stack stack) = emptystack(stacksize,emptystack(1,Unbound))

let labelcom (dl: com list) = let dlr = ref(dl) in
	let ldlr = ref([]) in
	while not (!dlr = []) do
	 let i = List.hd !dlr in
	 ldlr := !ldlr @ [Com1(i)];
	 dlr := List.tl !dlr
	done;
	Coml(!ldlr)
	
let labeldec (dl: (ide * exp) list) = let dlr = ref(dl) in
	let ldlr = ref([]) in
	while not (!dlr = []) do
	 let i = List.hd !dlr in
	 ldlr := !ldlr @ [Dec1(i)];
	 dlr := List.tl !dlr
	done;
	Decl(!ldlr)
	
let envstack = emptystack(stacksize,(emptyenv Unbound))

let storestack = emptystack(stacksize,(emptystore Undefined))

let pushenv(r) = push(r,envstack)

let topenv() = top(envstack)

let popenv () = pop(envstack)

let svuotaenv() = svuota(envstack)

let pushstore(s) = push(s,storestack)

let popstore () = pop(storestack)

let svuotastore () = svuota(storestack)

let topstore() = top(storestack)

let (labelstack: labeledconstruct stack) =
  emptystack(stacksize,Expr1(Eint(0))) 
  
  
let pushargs ((b: exp list),(continuation: labeledconstruct stack)) = 
     let br = ref(b) in
      while not(!br = []) do
	    push(Exprd1(List.hd !br),continuation);
	    br := List.tl !br
	  done

let getargs ((b: exp list),(tempstack: dval stack)) = 
      let br = ref(b) in
      let er = ref([]) in
      while not(!br = []) do
	    let arg=top(tempstack) in
	pop(tempstack); er := !er @ [arg];
	    br := List.tl !br
	  done;
	  !er